---
title: 'Home Automation'
---

# Step 1. - Switches & Firmware
Sonoff Basic [On Amazon Rs. 650](https://www.amazon.in/gp/product/B06WWNBD3Y/ref=ppx_yo_dt_b_asin_title_o03_s00?ie=UTF8&psc=1)

[ESPEasy](https://github.com/letscontrolit/ESPEasy/releases)

# Step 2. - Load ESP Easy firmware on it
[A good blog](https://randomnerdtutorials.com/sonoff-basic-switch-esp-easy-firmware-node-red/)

The firware is `ESP_Easy_mega-20190630_normal_ESP8266_1M`

The pin connection is easy. Add the header to the pin out from the I2C programming board and connect the RX -> TX and TX -> RX. 3.3v.

Just unplug the 3.3v line and press the reset button while connecting it to go into programming mode and then flash using the flasher which is downloaded with the firmware

# Step 3. - Configure the firmware for Sonoff
###### Under "Hardware":

Wifi Status LED -> GPIO-13 (D7)

Inversed LED -> Checked

###### Under "Devices":
Edit Task 1

`Device:` is `Switch input - Switch`

`Name` is `Doesn't Matter`

`Enabled` is `Checked`

`GPIO` is `GPIO-12 (D6)`

`Switch Type` is `Switch`

`Switch Button Type` is `Normal Switch`

# Step 4. - Test
`Off` = `http://${IP_ADDRESS}/control?cmd=GPIO,12,0`

`On` = `http://${IP_ADDRESS}/control?cmd=GPIO,12,0`

# Step 5. - Install Mosquitto on a Raspberry Pi
### First get the repository package signing key, import it into apt, and remove the key file again:
```
wget http://repo.mosquitto.org/debian/mosquitto-repo.gpg.key
sudo apt-key add mosquitto-repo.gpg.key
rm mosquitto-repo.gpg.key
```

### Then make the mosquitto repository available to apt:
```
cd /etc/apt/sources.list.d/
sudo wget http://repo.mosquitto.org/debian/mosquitto-stretch.list
sudo apt-get update
```

### Now we can install the core packages (server & clients):
```
sudo apt-get install mosquitto mosquitto-clients
```